Index: palm/trunk/UTIL/inifor/src/inifor.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3556)
+++ palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3557)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Updated documentation
+! 
+! 3537 2018-11-20 10:53:14Z eckhard
 ! Print version number on program start
 ! 
@@ -54,5 +57,5 @@
 ! Authors:
 ! --------
-! @author Eckhard Kadasch
+!> @author Eckhard Kadasch, (Deutscher Wetterdienst, Offenbach)
 !
 ! Description:
@@ -84,26 +87,30 @@
     IMPLICIT NONE
     
-    INTEGER                                 ::  igroup
-    INTEGER                                 ::  ivar
-    INTEGER                                 ::  iter
-    REAL(dp), ALLOCATABLE, DIMENSION(:,:,:) ::  output_arr
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_centre
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_arr
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_arr
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_north
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_south
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_east
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_west
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_north
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_south
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_east
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_west
-    REAL(dp), POINTER, DIMENSION(:)         ::  internal_arr
-    REAL(dp), POINTER, DIMENSION(:)         ::  ug_vg_arr
-    TYPE(nc_var), POINTER                   ::  output_var
-    TYPE(io_group), POINTER                 ::  group
-    TYPE(container), ALLOCATABLE            ::  input_buffer(:)
-    LOGICAL, SAVE                           ::  ug_vg_have_been_computed = .FALSE.
-    LOGICAL, SAVE                           ::  debugging_output = .TRUE.
+    INTEGER ::  igroup !< loop index for IO groups
+    INTEGER ::  ivar   !< loop index for output variables
+    INTEGER ::  iter   !< loop index for time steps
+
+    REAL(dp), ALLOCATABLE, DIMENSION(:,:,:)     ::  output_arr !< array buffer for interpolated quantities
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_centre !< density profile of the centre averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_arr     !< geostrophic wind in x direction
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_arr     !< geostrophic wind in y direction
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_north  !< density profile of the northern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_south  !< density profile of the southern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_east   !< density profile of the eastern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_west   !< density profile of the western averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_north    !< pressure profile of the northern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_south    !< pressure profile of the southern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_east     !< pressure profile of the eastern averaging domain
+    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_west     !< pressure profile of the western averaging domain
+
+    REAL(dp), POINTER, DIMENSION(:) ::  internal_arr !< pointer to the currently processed internal array (density, pressure)
+    REAL(dp), POINTER, DIMENSION(:) ::  ug_vg_arr    !< pointer to the currently processed geostrophic wind component
+
+    TYPE(nc_var), POINTER        ::  output_var      !< pointer to the currently processed output variable
+    TYPE(io_group), POINTER      ::  group           !< pointer to the currently processed IO group
+    TYPE(container), ALLOCATABLE ::  input_buffer(:) !< buffer of the current IO group's input arrays
+
+    LOGICAL, SAVE ::  ug_vg_have_been_computed = .FALSE. !< flag for managing geostrophic wind allocation and computation
+    LOGICAL, SAVE ::  debugging_output = .TRUE.          !< flag controllging output of internal variables
     
 !> \mainpage About INIFOR
@@ -116,22 +123,27 @@
     CALL report('main_loop', 'Running INIFOR version ' // VERSION)
 
-    ! Initialize INIFOR's parameters from command-line interface and namelists
+!
+!-- Initialize INIFOR's parameters from command-line interface and namelists
     CALL setup_parameters()
 
-    ! Initialize all grids, including interpolation neighbours and weights
+!
+!-- Initialize all grids, including interpolation neighbours and weights
     CALL setup_grids()
  CALL run_control('time', 'init')
 
-    ! Initialize the netCDF output file and define dimensions
+!
+!-- Initialize the netCDF output file and define dimensions
     CALL setup_netcdf_dimensions(output_file, palm_grid, cfg % start_date,    &
                                  origin_lon, origin_lat)
  CALL run_control('time', 'write')
 
-    ! Set up the tables containing the input and output variables and set
-    ! the corresponding netCDF dimensions for each output variable
+!
+!-- Set up the tables containing the input and output variables and set
+!-- the corresponding netCDF dimensions for each output variable
     CALL setup_variable_tables(cfg % ic_mode)
  CALL run_control('time', 'write')
 
-    ! Add the output variables to the netCDF output file
+!
+!-- Add the output variables to the netCDF output file
     CALL setup_netcdf_variables(output_file % name, output_var_table,          &
                                 cfg % debug)
@@ -143,5 +155,4 @@
 !- Section 2: Main loop
 !------------------------------------------------------------------------------
-
     DO igroup = 1, SIZE(io_group_list)
 
@@ -345,9 +356,9 @@
  CALL run_control('time', 'comp')
 
-
-                   ! This case gets called twice, the first time for ug, the
-                   ! second time for vg. We compute ug and vg at the first call
-                   ! and keep vg (and ug for that matter) around for the second
-                   ! call.
+!
+!--                This case gets called twice, the first time for ug, the
+!--                second time for vg. We compute ug and vg at the first call
+!--                and keep vg (and ug for that matter) around for the second
+!--                call.
                    CASE ( 'geostrophic winds' )
 
@@ -360,9 +371,10 @@
                             vg_arr = cfg % vg
                          ELSE
-                            CALL geostrophic_winds( p_north, p_south, p_east,     &
-                                                    p_west, rho_centre, f3,      &
-                                                    averaging_width_ew,           &
-                                                    averaging_width_ns,           &
-                                                    phi_n, lambda_n, phi_centre, lam_centre, &
+                            CALL geostrophic_winds( p_north, p_south, p_east,  &
+                                                    p_west, rho_centre, f3,    &
+                                                    averaging_width_ew,        &
+                                                    averaging_width_ns,        &
+                                                    phi_n, lambda_n,           &
+                                                    phi_centre, lam_centre,    &
                                                     ug_arr, vg_arr )
                          END IF
@@ -372,5 +384,6 @@
                       END IF
 
-                      ! Prepare output of geostrophic winds
+!
+!--                   Prepare output of geostrophic winds
                       SELECT CASE(TRIM(output_var % name))
                       CASE ('ls_forcing_ug')
@@ -397,10 +410,4 @@
                       SELECT CASE (TRIM(output_var % name))
 
-                      !CASE('ls_forcing_ug')
-                      !    output_arr(1, 1, :) = ug
-
-                      !CASE('ls_forcing_vg')
-                      !    output_arr(1, 1, :) = vg
-
                       CASE('nudging_tau')
                           output_arr(1, 1, :) = NUDGING_TAU
@@ -418,5 +425,4 @@
                                 "has not been implemented, yet."
                       CALL abort('main loop', message)
-                      !ALLOCATE( output_arr( 1, 1, 1:nz ) )
 
                    CASE DEFAULT
@@ -444,5 +450,7 @@
                 END IF
 
-             END DO ! ouput variables
+!
+!--          output variable loop
+             END DO
 
              ug_vg_have_been_computed = .FALSE.
@@ -463,8 +471,9 @@
              END IF
 
+!
+!--          Keep input buffer around for averaged (radiation) and 
+!--          accumulated COSMO quantities (precipitation).
              IF ( group % kind == 'running average' .OR. &
                   group % kind == 'accumulated' )  THEN
-                ! Keep input buffer around for averaged (radiation) and 
-                ! accumulated COSMO-DE quantities (precipitation).
              ELSE
                 CALL report('main loop', 'Deallocating input buffer', cfg % debug)
@@ -473,5 +482,7 @@
  CALL run_control('time', 'alloc')
 
-          END DO ! time steps / input files 
+!
+!--       time steps / input files loop
+          END DO
 
           IF (ALLOCATED(input_buffer))  THEN
@@ -491,7 +502,11 @@
           CALL report('main loop', message, cfg % debug)
 
-       END IF ! IO group % to_be_processed
-
-    END DO ! IO groups
+!
+!--    IO group % to_be_processed conditional
+       END IF
+
+!
+!-- IO groups loop
+    END DO
 
 !------------------------------------------------------------------------------
Index: palm/trunk/UTIL/inifor/src/inifor_control.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_control.f90	(revision 3556)
+++ palm/trunk/UTIL/inifor/src/inifor_control.f90	(revision 3557)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Updated documentation
+! 
+! 
+! 3447 2018-10-29 15:52:54Z eckhard
 ! Renamed source files for compatibilty with PALM build system
 !
@@ -44,5 +48,5 @@
 ! Authors:
 ! --------
-! @author Eckhard Kadasch
+!> @author Eckhard Kadasch (Deutscher Wetterdienst, Offenbach)
 !
 ! Description:
@@ -61,19 +65,31 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=5000) ::  message = ''
+    CHARACTER (LEN=5000) ::  message = '' !< log message buffer
 
  CONTAINS
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> report() is INIFOR's general logging routine. It prints the given 'message'
+!> to the terminal and writes it to the INIFOR log file.
+!> 
+!> You can use this routine to log events across INIFOR's code to log. For
+!> warnings and abort messages, you may use the dedicated routines warn() and
+!> abort() in this module. Both use report() and add specific behaviour to it.
+!------------------------------------------------------------------------------!
     SUBROUTINE report(routine, message, debug)
 
-       CHARACTER(LEN=*), INTENT(IN)  ::  routine
-       CHARACTER(LEN=*), INTENT(IN)  ::  message
-       LOGICAL, OPTIONAL, INTENT(IN) ::  debug
-       INTEGER                       ::  u
-       LOGICAL, SAVE                 ::  is_first_run = .TRUE.
-       LOGICAL                       ::  suppress_message
-
-
-       IF (is_first_run)  THEN
+       CHARACTER(LEN=*), INTENT(IN)  ::  routine !< name of calling subroutine of function
+       CHARACTER(LEN=*), INTENT(IN)  ::  message !< log message
+       LOGICAL, OPTIONAL, INTENT(IN) ::  debug   !< flag the current message as debugging message
+
+       INTEGER                       ::  u                     !< Fortran file unit for the log file
+       LOGICAL, SAVE                 ::  is_first_run = .TRUE. !< control flag for file opening mode
+       LOGICAL                       ::  suppress_message      !< control falg for additional debugging log
+
+
+       IF ( is_first_run )  THEN
           OPEN( NEWUNIT=u, FILE='inifor.log', STATUS='replace' )
           is_first_run = .FALSE.
@@ -84,9 +100,9 @@
 
        suppress_message = .FALSE.
-       IF (PRESENT(debug))  THEN
-          IF (.NOT. debug)  suppress_message = .TRUE.
+       IF ( PRESENT(debug) )  THEN
+          IF ( .NOT. debug )  suppress_message = .TRUE.
        END IF
 
-       IF (.NOT. suppress_message)  THEN
+       IF ( .NOT. suppress_message )  THEN
           PRINT *, "inifor: " // TRIM(message) // "  [ " // TRIM(routine) // " ]"
           WRITE(u, *)  TRIM(message) // "  [ " // TRIM(routine) // " ]"
@@ -98,8 +114,18 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> warn() prepends "WARNING:" the given 'message' and prints the result to the
+!> terminal and writes it to the INIFOR logfile.
+!> 
+!> You can use this routine for messaging issues, that still allow INIFOR to
+!> continue.
+!------------------------------------------------------------------------------!
     SUBROUTINE warn(routine, message)
 
-       CHARACTER(LEN=*), INTENT(IN) ::  routine
-       CHARACTER(LEN=*), INTENT(IN) ::  message
+       CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
+       CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
 
        CALL report(routine, "WARNING: " // TRIM(message))
@@ -108,8 +134,18 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> abort() prepends "ERROR:" the given 'message' and prints the result to the
+!> terminal, writes it to the INIFOR logfile, and exits INIFOR.
+!> 
+!> You can use this routine for messaging issues, that are critical and prevent
+!> INIFOR from continueing.
+!------------------------------------------------------------------------------!
     SUBROUTINE abort(routine, message)
 
-       CHARACTER(LEN=*), INTENT(IN) ::  routine
-       CHARACTER(LEN=*), INTENT(IN) ::  message
+       CHARACTER(LEN=*), INTENT(IN) ::  routine !< name of calling subroutine or function
+       CHARACTER(LEN=*), INTENT(IN) ::  message !< log message
 
        CALL report(routine, "ERROR: " // TRIM(message) // " Stopping.")
@@ -119,4 +155,10 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> print_version() prints the INIFOR version number and copyright notice.
+!------------------------------------------------------------------------------!
     SUBROUTINE print_version()
        PRINT *, "INIFOR " // VERSION
@@ -125,15 +167,26 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> 
+!> run_control() measures the run times of various parts of INIFOR and
+!> accumulates them in timing budgets.
+!------------------------------------------------------------------------------!
     SUBROUTINE run_control(mode, budget)
 
-       CHARACTER(LEN=*), INTENT(IN) ::  mode, budget
-       REAL(dp), SAVE               ::  t0, t1
-       REAL(dp), SAVE               ::  t_comp=0.0_dp, &
-                                        t_alloc=0.0_dp, &
-                                        t_init=0.0_dp, &
-                                        t_read=0.0_dp, &
-                                        t_total=0.0_dp, &
-                                        t_write=0.0_dp
-       CHARACTER(LEN=*), PARAMETER  ::  fmt='(F6.2)'
+       CHARACTER(LEN=*), INTENT(IN) ::  mode   !< name of the calling mode
+       CHARACTER(LEN=*), INTENT(IN) ::  budget !< name of the timing budget
+
+       REAL(dp), SAVE ::  t0               !< begin of timing interval
+       REAL(dp), SAVE ::  t1               !< end of timing interval
+       REAL(dp), SAVE ::  t_comp  = 0.0_dp !< computation timing budget
+       REAL(dp), SAVE ::  t_alloc = 0.0_dp !< allocation timing budget
+       REAL(dp), SAVE ::  t_init  = 0.0_dp !< initialization timing budget
+       REAL(dp), SAVE ::  t_read  = 0.0_dp !< reading timing budget
+       REAL(dp), SAVE ::  t_total = 0.0_dp !< total time
+       REAL(dp), SAVE ::  t_write = 0.0_dp !< writing timing budget
+
+       CHARACTER(LEN=*), PARAMETER  ::  fmt='(F6.2)' !< floating-point output format
 
 
Index: palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3556)
+++ palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3557)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Updated documentation
+! 
+! 
+! 3537 2018-11-20 10:53:14Z eckhard
 ! Bumped version number
 ! 
@@ -59,5 +63,5 @@
 ! Authors:
 ! --------
-! @author Eckhard Kadasch
+!> @author Eckhard Kadasch (Deutscher Wetterdienst, Offenbach)
 !
 ! Description:
@@ -68,6 +72,7 @@
  
  IMPLICIT NONE
- 
- ! Parameters for type definitions
+
+! 
+!-- Parameters for type definitions
  INTEGER, PARAMETER  ::  dp    = 8   !< double precision (8 bytes = 64 bits)
  INTEGER, PARAMETER  ::  sp    = 4   !< single precision (4 bytes = 32 bits)
@@ -78,29 +83,38 @@
  INTEGER, PARAMETER  ::  DATE  = 10  !< length of date strings
 
- ! Trigonomentry
+! 
+!-- Trigonomentry
  REAL(dp), PARAMETER ::  PI = 3.14159265358979323846264338_dp !< Ratio of a circle's circumference to its diamter [-]
  REAL(dp), PARAMETER ::  TO_RADIANS = PI / 180.0_dp           !< Conversion factor from degrees to radiant [-]
  REAL(dp), PARAMETER ::  TO_DEGREES = 180.0_dp / PI           !< Conversion factor from radians to degrees [-]
 
- ! COSMO-DE parameters
- INTEGER, PARAMETER  ::  WATER_ID = 9                         !< Integer corresponding to the water soil type in COSMO-DE [-]
- REAL(dp), PARAMETER ::  EARTH_RADIUS = 6371229.0_dp          !< Earth radius used in COSMO-DE [m]
- REAL(dp), PARAMETER ::  P_SL = 1e5_dp                        !< Reference pressure for computation of COSMO-DE's basic state pressure [Pa]
- REAL(dp), PARAMETER ::  T_SL = 288.15_dp                     !< Reference temperature for computation of COSMO-DE's basic state pressure [K]
- REAL(dp), PARAMETER ::  BETA = 42.0_dp                       !< logarithmic lapse rate, dT / d ln(p), for computation of COSMO-DE's basic state pressure [K]
- REAL(dp), PARAMETER ::  RD   = 287.05_dp                     !< specific gas constant of dry air, used in computation of COSMO-DE's basic state [J/kg/K]
- REAL(dp), PARAMETER ::  RV   = 461.51_dp                     !< specific gas constant of water vapor [J/kg/K]
- REAL(dp), PARAMETER ::  G    = 9.80665_dp                    !< acceleration of Earth's gravity, used in computation of COSMO-DE's basic state [m/s/s]
- REAL(dp), PARAMETER ::  RHO_L = 1e3_dp                       !< density of liquid water, used to convert W_SO from [kg/m^2] to [m^3/m^3], in [kg/m^3]
- REAL(dp), PARAMETER ::  HECTO = 100_dp                       !< unit conversion factor from hPa to Pa
+! 
+!-- COSMO-DE parameters
+ INTEGER, PARAMETER  ::  WATER_ID = 9                !< Integer corresponding to the water soil type in COSMO-DE [-]
+ REAL(dp), PARAMETER ::  EARTH_RADIUS = 6371229.0_dp !< Earth radius used in COSMO-DE [m]
+ REAL(dp), PARAMETER ::  P_SL = 1e5_dp               !< Reference pressure for computation of COSMO-DE's basic state pressure [Pa]
+ REAL(dp), PARAMETER ::  T_SL = 288.15_dp            !< Reference temperature for computation of COSMO-DE's basic state pressure [K]
+ REAL(dp), PARAMETER ::  BETA = 42.0_dp              !< logarithmic lapse rate, dT / d ln(p), for computation of COSMO-DE's basic
+                                                     !< state pressure [K]
+ REAL(dp), PARAMETER ::  RD   = 287.05_dp            !< specific gas constant of dry air, used in computation of COSMO-DE's basic
+                                                     !< state [J/kg/K]
+ REAL(dp), PARAMETER ::  RV   = 461.51_dp            !< specific gas constant of water vapor [J/kg/K]
+ REAL(dp), PARAMETER ::  G    = 9.80665_dp           !< acceleration of Earth's gravity, used in computation of COSMO-DE's basic
+                                                     !< state [m/s/s]
+ REAL(dp), PARAMETER ::  RHO_L = 1e3_dp              !< density of liquid water, used to convert W_SO from [kg/m^2] to [m^3/m^3],
+                                                     !< in [kg/m^3]
+ REAL(dp), PARAMETER ::  HECTO = 100_dp              !< unit conversion factor from hPa to Pa
 
- ! PALM-4U parameters
- REAL(dp), PARAMETER ::  OMEGA   = 7.29e-5_dp                 !< angular velocity of Earth's rotation [s^-1]
- REAL(dp), PARAMETER ::  P_REF   = 1e5_dp                     !< Reference pressure for potential temperature [Pa]
- REAL(dp), PARAMETER ::  RD_PALM = 287.0_dp                   !< specific gas constant of dry air, used in computation of PALM-4U's potential temperature [J/kg/K]
- REAL(dp), PARAMETER ::  CP_PALM = 1005.0_dp                  !< heat capacity of dry air at constant pressure, used in computation of PALM-4U's potential temperature [J/kg/K]
+!
+!-- PALM-4U parameters
+ REAL(dp), PARAMETER ::  OMEGA   = 7.29e-5_dp !< angular velocity of Earth's rotation [s^-1]
+ REAL(dp), PARAMETER ::  P_REF   = 1e5_dp     !< Reference pressure for potential temperature [Pa]
+ REAL(dp), PARAMETER ::  RD_PALM = 287.0_dp   !< specific gas constant of dry air, used in computation of PALM-4U's potential temperature [J/kg/K]
+ REAL(dp), PARAMETER ::  CP_PALM = 1005.0_dp  !< heat capacity of dry air at constant pressure, used in computation of PALM-4U's potential temperature [J/kg/K]
 
- ! INIFOR parameters
- INTEGER, PARAMETER          ::  FILL_ITERATIONS = 5          !< Number of iterations for extrapolating soil data into COSMO-DE water cells [-]
+!
+!-- INIFOR parameters
+ INTEGER, PARAMETER          ::  FILL_ITERATIONS = 5          !< Number of iterations for extrapolating soil data into COSMO-DE
+                                                              !< water cells [-]
  INTEGER, PARAMETER          ::  FORCING_STEP = 1             !< Number of hours between forcing time steps [h]
  REAL(dp), PARAMETER         ::  NUDGING_TAU = 21600.0_dp     !< Nudging relaxation time scale [s]
